#pragma once

#include "const.h"
#include "IModule.h"
#include "InstallController.h"

/**
* @class IInstallModuleCallback
* InstallModule   Callback ϱ  Interafce 
* ο ȴ.
*
* @author : DaeMyung.Kang
*/
class IInstallModuleCallback : public ICallback
{
public:
	IInstallModuleCallback()
	{

	}

	virtual ~IInstallModuleCallback()
	{

	}

	virtual CALLBACK_RETURN OnStart()
	{
		return CALLBACK_RETURN_CONTINUE;
	}

	/** 
	* @fn CALLBACK_RETURN OnFinished(CALLBACK_FINISHED_STATUS status)
	* @brief Install ۾   ˷ִ Callback
	* @param
	*			status		:  ¸ ˷ش.(  , ,  )
	* @return 
	*			CALLBACK_RETURN_CANCEL		:  ۾ Ѵ.
	*			CALLBACK_RETURN_CONTINUE	:  ۾ Ѵ.
	*/
	virtual CALLBACK_RETURN OnFinished(CALLBACK_FINISHED_STATUS status, ERRORINFO *info ) = 0;
};

class IInstallModule : public IModule
{
public:
	IInstallModule(const TCHAR *guid) : IModule(guid)
	{

	}

	virtual ~IInstallModule()
	{

	}

	/** 
	* @fn BOOL Install(IInstallModuleCallback* callback)
	* @brief Install ۾ ϴ 
	* @param
	*			status		:  ¸ ˷ش.(  , ,  )
	* @return 
	*			CALLBACK_RETURN_CANCEL		:  ۾ Ѵ.
	*			CALLBACK_RETURN_CONTINUE	:  ۾ Ѵ.
	*/
	BOOL Install(IInstallModuleCallback* callback);
	virtual BOOL Install() = 0;

	IInstallModuleCallback *GetCallback();
};